#!/usr/bin/env python
# Eclipse SUMO, Simulation of Urban MObility; see https://eclipse.dev/sumo
# Copyright (C) 2009-2023 German Aerospace Center (DLR) and others.
# This program and the accompanying materials are made available under the
# terms of the Eclipse Public License 2.0 which is available at
# https://www.eclipse.org/legal/epl-2.0/
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the Eclipse
# Public License 2.0 are satisfied: GNU General Public License, version 2
# or later which is available at
# https://www.gnu.org/licenses/old-licenses/gpl-2.0-standalone.html
# SPDX-License-Identifier: EPL-2.0 OR GPL-2.0-or-later

# @file    test.py
# @author  Pablo Alvarez Lopez
# @date    2016-11-25

# import common functions for netedit tests
import os
import sys

testRoot = os.path.join(os.environ.get('SUMO_HOME', '.'), 'tests')
neteditTestRoot = os.path.join(
    os.environ.get('TEXTTEST_HOME', testRoot), 'netedit')
sys.path.append(neteditTestRoot)
import neteditTestFunctions as netedit  # noqa

# Open netedit
neteditProcess, referencePosition = netedit.setupAndStart(neteditTestRoot)

# go to additional mode
netedit.additionalMode()

# select E2
netedit.changeElement("laneAreaDetector")

# create E2
netedit.leftClick(referencePosition, 520, 210)

# go to inspect mode
netedit.inspectMode()

# inspect first E2
netedit.leftClick(referencePosition, 480, 210)

# Change parameter pos with a non valid value (dummy)
netedit.modifyAttribute(netedit.attrs.E2.inspect.pos, "dummyPos", True)

# Change parameter pos with a valid value (negative)
netedit.modifyAttribute(netedit.attrs.E2.inspect.pos, "-5", True)

# Change parameter pos with a valid value (> lane length)
netedit.modifyAttribute(netedit.attrs.E2.inspect.pos, "400", True)

# Change parameter pos with a valid value
netedit.modifyAttribute(netedit.attrs.E2.inspect.pos, "20", True)

# Check undos and redos
netedit.undo(referencePosition, 4)
netedit.redo(referencePosition, 4)

# save netedit config
netedit.saveNeteditConfig(referencePosition)

# quit netedit
netedit.quit(neteditProcess)
